/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reset_cartucho;

import com.panamahitek.ArduinoException;
import com.panamahitek.PanamaHitek_Arduino;
import java.util.Enumeration;
import gnu.io.CommPortIdentifier;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import jssc.SerialPortEvent;
import jssc.SerialPortEventListener;
import jssc.SerialPortException;

/**
 *
 * @author alex
 */
public class index extends javax.swing.JFrame {

    PanamaHitek_Arduino ino = new PanamaHitek_Arduino();
    javax.swing.JFrame par = this;
    SerialPortEventListener listener = new SerialPortEventListener() {
        @Override
        public void serialEvent(SerialPortEvent spe) {
            try {
                if (ino.isMessageAvailable()) {
                    txt_area.setText(txt_area.getText().toString() + ino.printMessage().toString() + "\n");
                    txt_area.setCaretPosition(txt_area.getDocument().getLength());
                }
            } catch (SerialPortException ex) {
                Logger.getLogger(index.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showMessageDialog(par, "Ocurrió un error al establecer comunicación con el arduino\nNo se puede obtener los datos del puerto Serial", "ERROR", JOptionPane.ERROR_MESSAGE);
                System.exit(0);
            } catch (ArduinoException ex) {
                Logger.getLogger(index.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showMessageDialog(par, "Ocurrió un error al establecer comunicación con el arduino\nNo se puede obtener los datos del puerto Serial", "ERROR", JOptionPane.ERROR_MESSAGE);
                System.exit(0);
            }
        }
    };

    /**
     * Creates new form index
     */
    public index() {
        initComponents();
        btn_conectar.setAlignmentX(chk_editar.getAlignmentX());
        btn_conectar.setAlignmentY(chk_editar.getAlignmentY());
        btn_conectar.setVisible(false);
        Dimension tamanhoTextArea = txt_area.getSize();
        Point p = new Point(
                0,
                tamanhoTextArea.height);
        scroll.getViewport().setViewPosition(p);
        txt_area.setWrapStyleWord(true);
        txt_area.setCaretPosition(txt_area.getDocument().getLength());
        txt_baudios.setEnabled(false);
        txt_baudios.setText("115200");
        cbx_com.removeAllItems();
        Enumeration listaPuertos = CommPortIdentifier.getPortIdentifiers();
        CommPortIdentifier idPuerto = null;
        while (listaPuertos.hasMoreElements()) {
            idPuerto = (CommPortIdentifier) listaPuertos.nextElement();
            if (idPuerto.getPortType() == CommPortIdentifier.PORT_SERIAL) {
                cbx_com.addItem(idPuerto.getName());
            }
        }

        if (cbx_com.getSelectedItem() != null && !cbx_com.getSelectedItem().toString().isEmpty()) {
            try {
                ino.arduinoRXTX(cbx_com.getSelectedItem().toString().toUpperCase().trim(), Integer.parseInt(txt_baudios.getText().trim()), listener);
            } catch (ArduinoException ex) {
                Logger.getLogger(index.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showMessageDialog(par, "Ocurrió un error al establecer comunicación con el arduino\nEl Puerto " + cbx_com.getSelectedItem().toString() + " puede estar en uso.", "ERROR", JOptionPane.ERROR_MESSAGE);
                System.exit(0);
            }
        } else {
            JOptionPane.showMessageDialog(par, "No hay Puertos para Listar", "ERROR", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        txt_baudios = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        btn_reset = new javax.swing.JButton();
        cbx_com = new javax.swing.JComboBox<>();
        scroll = new javax.swing.JScrollPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        txt_area = new javax.swing.JTextArea();
        btn_conectar = new javax.swing.JButton();
        chk_editar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Resetear Cartucho");

        txt_baudios.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txt_baudiosKeyPressed(evt);
            }
        });

        jLabel1.setText("Puerto COM:");

        jLabel2.setText("Baudios:");

        btn_reset.setText("Resetar Cartucho");
        btn_reset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_resetActionPerformed(evt);
            }
        });

        cbx_com.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        txt_area.setColumns(20);
        txt_area.setRows(5);
        jScrollPane1.setViewportView(txt_area);

        scroll.setViewportView(jScrollPane1);

        btn_conectar.setText("Conectar");
        btn_conectar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_conectarActionPerformed(evt);
            }
        });

        chk_editar.setText("Modificar");
        chk_editar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chk_editarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(37, 37, 37)
                .addComponent(btn_reset, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(55, 55, 55))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(cbx_com, javax.swing.GroupLayout.PREFERRED_SIZE, 153, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(txt_baudios, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGap(200, 200, 200)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                        .addComponent(jLabel2)
                        .addGap(43, 43, 43)))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(btn_conectar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chk_editar)
                .addGap(40, 40, 40))
            .addComponent(scroll)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(43, 43, 43)
                .addComponent(btn_reset, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(29, 29, 29)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txt_baudios, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbx_com, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_conectar)
                    .addComponent(chk_editar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(scroll, javax.swing.GroupLayout.PREFERRED_SIZE, 144, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btn_resetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_resetActionPerformed
        // TODO add your handling code here:
        try {
            ino.sendByte(13);
        } catch (ArduinoException e) {
            JOptionPane.showMessageDialog(par, "Ocurrió un error al enviar mensaje al arduino\nNo se puede enviar datos a través del puerto Serial", "ERROR", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        } catch (SerialPortException ex) {
            Logger.getLogger(index.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(par, "Ocurrió un error al enviar mensaje al arduino\nNo se puede enviar datos a través del puerto Serial", "ERROR", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        }
    }//GEN-LAST:event_btn_resetActionPerformed

    private void btn_conectarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_conectarActionPerformed
        // TODO add your handling code here:
        reconnectPort();
    }//GEN-LAST:event_btn_conectarActionPerformed

    private void chk_editarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chk_editarActionPerformed
        // TODO add your handling code here:
        txt_baudios.setEnabled(true);
        chk_editar.setVisible(false);
        btn_conectar.setVisible(true);
    }//GEN-LAST:event_chk_editarActionPerformed

    private void txt_baudiosKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txt_baudiosKeyPressed
        // TODO add your handling code here:
        if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
            reconnectPort();
        }
        if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
            txt_baudios.setEnabled(false);
            chk_editar.setVisible(true);
            btn_conectar.setVisible(false);
        }
    }//GEN-LAST:event_txt_baudiosKeyPressed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(index.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(index.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(index.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(index.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new index().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_conectar;
    private javax.swing.JButton btn_reset;
    private javax.swing.JComboBox<String> cbx_com;
    private javax.swing.JButton chk_editar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane scroll;
    private javax.swing.JTextArea txt_area;
    private javax.swing.JTextField txt_baudios;
    // End of variables declaration//GEN-END:variables

    private void reconnectPort() {
        chk_editar.setVisible(true);
        btn_conectar.setVisible(false);
        try {
            ino.killArduinoConnection();
            ino.arduinoRXTX(cbx_com.getSelectedItem().toString().toUpperCase().trim(), Integer.parseInt(txt_baudios.getText().trim()), listener);
            JOptionPane.showMessageDialog(par, "Conexión reiniciada con el puerto " + cbx_com.getSelectedItem().toString().toUpperCase().trim() + " con " + Integer.parseInt(txt_baudios.getText().trim()) + " baudios", "INFORMACIÓN", JOptionPane.INFORMATION_MESSAGE);
        } catch (ArduinoException ex) {
            Logger.getLogger(index.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(par, "Ocurrió un error al establecer comunicación con el arduino\nEl Puerto " + cbx_com.getSelectedItem().toString() + " puede estar en uso.", "ERROR", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        }
        txt_baudios.setEnabled(false);
    }
}
